unit WindMPP;
{     EGA, ⠪   Hercules,
ࠧ 㪢 ⠭ }
interface

uses Crt,KeyStrok,Graph,Windows,Messages,Tables;

var MainWindow,TableWindow ,HelpW,
    DownWindow,UpLWindow,UpRWindow,
    DownLWindow,UpWindow,DownRWindow,
    LeftWindow,RightWindow               :Window;
    MainTable                     : table;
    TimeCount, Tvelosity,CheckKey,AltCheckKey : Word;

procedure EditInt(comm:string; var i:integer);

procedure EditReal(comm:string; var r:real);

procedure CheckPoint(rewrite: boolean);

procedure Clear;

{procedure Cursor( var x,y :real;var s);}

implementation

const
  CharHeight=8;

var
  
  ScreenBack, TableBack, Fore: byte;

procedure EditInt(comm:string; var i:integer);
begin
  CreateEntry(i,comm,6,IntEntry,Enabled,0)
end;

procedure EditReal(comm:string; var r:real);
begin
  CreateRealEntry(r,comm,8,5,Enabled,0)
end;

procedure CheckPoint(rewrite:boolean);
var
  dummy: word;
begin
  CheckKey:=maxInt;
  if KeyPressed then begin dummy:=ReadKey;
  if Hi(dummy)=0 then CheckKey:=dummy else AltCheckKey:=dummy;
case dummy of
TabKey:   begin
            SelectWindow( TableWindow);
            DrawTable(MainTable);
            ModifyTable( MainTable);
          end; {if dummy=TabKey}
ord(' '): begin
            SelectWindow( TableWindow);
            DrawTable (MainTable); dummy:=1;
          end;{ if dummy=஡}
EndKey:   begin CloseGraph; halt (0); end;
DeleteKey :begin EraseWindow(MainWindow);
                 CloseWindow(UpLWindow);
                 CloseWindow(UpRWindow);
                 CloseWindow(DownLWindow);
                 CloseWindow(DownRWindow);
                 CloseWindow(UplWindow);
                 CloseWindow(UpWindow);
                 CloseWindow(DownWindow);
                 CloseWindow(LeftWindow);
                 CloseWindow(RightWindow);

           end;
  end;
  end
  else if rewrite or (not TableShown(MainTable))
       or ((TimeCount mod Tvelosity)=0) then
   begin
       SelectWindow(TableWindow);
       DrawTable(MainTable);
{       SelectWindow(HelpW);
       SetColor(Fore) ;
       OutTextXY(2,2,
'    -室  ⠡;      -室  ;      - ࠭;      -.');
       SetColor(LightCyan) ;
       OutTextXY(2,2,
'Tab                      Esc                 Del                   End        ');}
   end;
  inc(TimeCount);
  SelectWindow(MainWindow);
end;

procedure Clear;
  begin
   EraseWindow(CurWindow);
  end;


const
  EGANonCurrent: PlaceColors = (Blue,Yellow);
  EGACurrent: PlaceColors = (Magenta,LightCyan);
  HercNonCurrent: PlaceColors = (0,1);
  HercCurrent: PlaceColors = (1,0);

var
  sx,sy,sh: word;
  max: longint;
  NonCurrent,Current: PlaceColors;

begin
  sh:=CharHeight+2*TextOffsetY+2; TimeCount:=0 ; Tvelosity:=1000 ;
  GetAspectRatio(sx,sy); max:=ScreenMaxY-sh; sx:=(max*sy) div sx;
  if (GraphDriver=EGA) or (GraphDriver=VGA) then begin
    NonCurrent:=EGANonCurrent; Current:=EGACurrent; ScreenBack:=Black;
    TableBack:=Blue; Fore:=Yellow;
  end else if GraphDriver=HercMono then begin
    NonCurrent:=HercNonCurrent; Current:=HercCurrent; ScreenBack:=0;
    TableBack:=0; Fore:=1;
  end else begin
    CloseGraph;
    Writeln('騩 ᪨   ন MPP');
    Halt(2)
  end;
  MakeWindow(MainWindow,0,sx,0,ScreenMaxY-sh,DoubleFrame(Fore,1),ScreenBack,
               Background,EraseOff,CloseOff);
  MakeWindow(TableWindow,sx,ScreenMaxX,0,ScreenMaxY-sh,SingleFrame(Fore),
               TableBack,Background,EraseOn,CloseOff);
  CreateTable(MainTable,TableWindow,Fore,NonCurrent,NonCurrent,Current);
  CreateWindow(DownWindow,2,sx-2,(ScreenMaxY-sh) div 2,ScreenMaxY-sh-2,
               SingleFrame(Yellow),Black,Background,EraseOff,CloseOn);
  CreateWindow(UpRWindow,sx div 2 ,sx-2,2,(ScreenMaxY-sh) div 2,
               SingleFrame(Yellow),Black,Background,EraseOff,CloseOn);
  CreateWindow(UpLWindow,2,sx div 2,2,(ScreenMaxY-sh) div 2,
               SingleFrame(Yellow),Black,Background,EraseOff,CloseOn);
  CreateWindow(UpWindow,2,sx-2,2,(ScreenMaxY-sh) div 2,
               SingleFrame(Yellow),Black,Background,EraseOff,CloseOn);
  CreateWindow(DownRWindow,sx div 2,sx-2,(ScreenMaxY-sh) div 2,ScreenMaxY-sh-2,
               SingleFrame(Yellow),Black,Background,EraseOff,CloseOn);
  CreateWindow(DownLWindow,2,(sx div 2)-2,(ScreenMaxY-sh) div 2,ScreenMaxY-sh-2,
               SingleFrame(Yellow),Black,Background,EraseOff,CloseOn);
  CreateWindow(LeftWindow,2,sx div 2,2,ScreenMaxY-sh-2,
               SingleFrame(Yellow),Black,Background,EraseOff,CloseOn);
  CreateWindow(RightWindow,sx div 2,sx-2,2,ScreenMaxY-sh-2,
               SingleFrame(Yellow),Black,Background,EraseOff,CloseOn);
  CreateWindow(DownLWindow,2,sx div 2,(ScreenMaxY-sh) div 2,ScreenMaxY-sh-2,
               SingleFrame(Yellow),Black,Background,EraseOff,CloseOn);
  MakeWindow(HelpW,0,ScreenMaxX,ScreenMaxY-sh,ScreenMaxY,SingleFrame(Fore),TableBack,
               Background,EraseOn,CloseOn);
  SelectWindow(HelpW);
  SetColor(Fore) ;
  OutTextXY(2,2,
'    -室  ⠡;      -室  ;      - ࠭;      -.');
  SetColor(LightCyan) ;
  OutTextXY(2,2,
'Tab                      Esc                 Del                   End        ');
  SelectWindow(MainWindow);
  AltCheckKey:=maxint;
end.

